<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :span="16" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="Judul, nomor pengumuman" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                    <el-button @click="showFilterDialog = true" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-funnel"></i> Filter
                    </el-button>
                </el-col>
                <el-col :span="8" class="text-align-right">
                    <el-button v-permission="[null, 'announcement', 'create']" @click="handleCreate" size="mini" type="success">
                        <i class="ion-ios-add-circle"></i> Tambah Pemberitahuan
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="announcements" ref="announcementTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column
                fixed="left"
                label="No. Pemberitahuan"
                width="200">
                <template slot-scope="scope">
                    <span style="color:#3E89FA;">{{ scope.row.number }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Judul"
                width="300">
                <template slot-scope="scope">
                    <span>{{ scope.row.title }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Kategori"
                width="175">
                <template slot-scope="scope">
                    <span>{{ scope.row.category.name }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Perumahan"
                width="250"
                v-if="['root', 'owner'].indexOf(me.role.slug) > -1">
                <template slot-scope="scope">
                    <span>{{ scope.row.residentials.map((x) => x.name).join(', ') }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Dibuat Oleh"
                width="150">
                <template slot-scope="scope">
                    <span>{{ scope.row.author.profile.fullname }}</span>
                </template>
            </el-table-column> 
            <el-table-column
                label="Status"
                width="150">
                <template slot-scope="scope">
                    <el-tag v-if="scope.row.status == 'publish'" type="success" size="mini">Dipublikasikan</el-tag>
                    <el-tag v-else type="info" size="mini">Disimpan</el-tag>
                </template>
            </el-table-column> 
            <el-table-column
                label="Terakhir Diubah"
                width="150">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="200">
                <template slot-scope="{row}">
                    <el-button v-permission="[row, 'announcement', 'viewown']" type="text" @click="handleEdit(row)">Ubah</el-button>
                    <el-button v-permission="[row, 'announcement', 'deleteown']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                    <el-button v-permission="[row, 'announcement', 'viewown']" type="text" class="text-info" @click="handleDownload(row)">Download PDF</el-button>
                </template>
            </el-table-column>
        </el-table>
        
        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch" />

        <el-dialog v-loading="filterLoading" title="Filter" :visible.sync="showFilterDialog" width="30%" :show-close="false" @closed="resetForm">
            <aside>
                <el-alert type="info" description="Tampilkan data pemberitahuan berdasarkan kriteria di bawah" :closable=false show-icon></el-alert>
            </aside>
            <el-form ref="filter" :model="filter">
                <el-form-item label="Kata Kunci" prop="keyword">
                    <el-input ref="keyword" name="keyword" v-model="filter.keyword" placeholder="Nama pengguna, no. handphone" autocomplete="off" maxlength="255" clearable></el-input>
                </el-form-item>
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Status" prop="status">
                            <el-select v-model="filter.status" placeholder="Pilih status" class="width-100" ref="status" name="status" clearable>
                                <el-option
                                    v-for="item in status"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Kategori" prop="category">
                            <el-select v-model="filter.category" placeholder="Pilih kategori" class="width-100" ref="category" name="category" clearable>
                                <el-option
                                    v-for="item in categories"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Dibuat Oleh" prop="author" clearable>
                            <el-select 
                                v-model="filter.author" 
                                placeholder="Ketik nama warga" 
                                class="width-100" 
                                ref="author" 
                                name="author"
                                clearable
                                filterable
                                remote
                                :remote-method="getUsers"
                                value-key="id"
                                >
                                <el-option
                                    v-for="item in users"
                                    :key="item.id"
                                    :label="item.profile.fullname"
                                    :value="item.id">
                                    <span style="float: left">{{ item.profile.fullname }}</span>
                                    <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.role.name }}</strong>
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :xs="24" v-if="['root', 'owner'].indexOf(me.role.slug) > -1">
                        <el-form-item label="Perumahan" prop="residential">
                            <el-select v-model="filter.residential" placeholder="Pilih perumahan" class="width-100" ref="residential" name="residential">
                                <el-option
                                    v-for="item in residentials"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>               
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showFilterDialog = false" size="medium">Batal</el-button>
                <el-button @click="handleSearch" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> Submit
                </el-button>
            </span>
        </el-dialog>

        <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="40%" :show-close="false" @closed="resetForm">
            <el-form ref="announcementForm" :model="announcementForm" :rules="announcementRules">
                <aside>
                    <el-alert type="info" description="Mengatur daftar semua pemberitahuan kepada seluruh pengguna berdasarkan masing-masing perumahan." :closable=false show-icon></el-alert>
                </aside>
                <el-form-item label="Judul" prop="title">
                    <el-input ref="title" name="title" v-model="announcementForm.title" placeholder="Judul pemberitahuan" autocomplete="off" min="0" maxlength="255" show-word-limit></el-input>
                </el-form-item> 
                <el-form-item label="Konten" prop="body">
                    <ckeditor :editor="editor" :config="editorConfig" v-model="announcementForm.body"></ckeditor>
                </el-form-item>               
                <el-row :gutter="20">                    
                    <el-col :lg="24" :md="24" :sm="24" v-if="['root', 'owner'].indexOf(me.role.slug) > -1">
                        <el-form-item label="Pilih perumahan atau kosongkan untuk kirim ke semua" prop="residentials">
                            <el-select 
                                v-model="announcementForm.residentials" 
                                placeholder="Pilih perumahan" 
                                class="width-100" 
                                ref="residentials" 
                                name="residentials"
                                multiple
                                filterable>
                                <el-option
                                    v-for="item in residentials"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>   
                <h3>Ditandatangani Oleh:</h3> 
                <div v-for="(item, index) of announcementForm.signedby" :key="index" class="dynamic-list">
                    <el-row :gutter="20">
                        <el-col :lg="12" :md="24" :sm="24">
                            <el-form-item label="Nama" :prop="item.name">
                                <el-input ref="name" name="name" v-model="item.name" placeholder="Nama lengkap" autocomplete="off" maxlength="255" show-word-limit></el-input>
                            </el-form-item> 
                        </el-col>
                        <el-col :lg="12" :md="24" :sm="24">
                            <el-form-item label="Jabatan" :prop="item.position">
                                <el-input ref="position" name="position" v-model="item.position" placeholder="Jabatan/Posisi" autocomplete="off" maxlength="255" show-word-limit></el-input>
                            </el-form-item> 
                        </el-col>
                    </el-row>
                    <el-form-item>
                        <el-button class="float-right margin-small-left" @click="deleteAction(index)" v-if="index > 0" icon="el-icon-delete" type="danger" size="mini">Hapus</el-button>
                        <el-button class="float-right" @click="addAction" v-if="(index + 1) == announcementForm.signedby.length" icon="el-icon-plus" type="success" size="mini"> Tambah</el-button>                        
                    </el-form-item>
                </div>                            
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :sm="24">
                        <el-form-item label="Kategori" prop="category">
                            <el-select v-model="announcementForm.category" placeholder="Pilih kategori" class="width-100" ref="category" name="category">
                                <el-option
                                    v-for="item in categories"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :sm="24">
                        <el-form-item label="Status" prop="status">
                            <el-select 
                                v-model="announcementForm.status" 
                                ref="status" 
                                name="status"
                                placeholder="Pilih perumahan" 
                                class="width-100">
                                <el-option
                                    v-for="item in status"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>                    
                </el-row>                
                <el-form-item label="" prop="medias">
                    <el-upload
                        name="media"
                        :action="uploadURL"
                        with-credentials
                        accept=" .jpg, .jpeg, .png, .doc, .docx, .xls, .xlsx, .pdf"
                        :headers="{'Authorization': 'Bearer ' + token.access_token}"
                        :on-success="handleUploadSuccess"
                        :on-remove="handleUploadRemove"
                        :before-upload="beforeUpload"
                        :file-list="uploadFileList">
                        <el-button size="small" type="primary">Lampiran</el-button>
                        <div slot="tip" class="el-upload__tip">Tipe file: jpg, png, doc/docx, xls/xlsx, pdf</div>
                    </el-upload>
                </el-form-item>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showDialog = false" size="medium">Batal</el-button>
                <el-button v-permission="[null, 'announcement', 'editown']" @click="handleSubmit" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                </el-button>                
            </span>
        </el-dialog>

    </div>
</template>
<script>
import moment from 'moment';
import html2pdf from 'html2pdf.js';
import ClassicEditor from '@ckeditor/ckeditor5-editor-classic/src/classiceditor';
import EssentialsPlugin from '@ckeditor/ckeditor5-essentials/src/essentials';
import BoldPlugin from '@ckeditor/ckeditor5-basic-styles/src/bold';
import ItalicPlugin from '@ckeditor/ckeditor5-basic-styles/src/italic';
import LinkPlugin from '@ckeditor/ckeditor5-link/src/link';
import ListPlugin from '@ckeditor/ckeditor5-list/src/list';
import ParagraphPlugin from '@ckeditor/ckeditor5-paragraph/src/paragraph';
import AlignmentPlugin from '@ckeditor/ckeditor5-alignment/src/alignment';
import HeadingPlugin from '@ckeditor/ckeditor5-heading/src/heading';
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight } from '@/utils/index';

export default {
    name: 'Announcement',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data(){

        return {
            editor: ClassicEditor,
            editorConfig: {
                plugins: [
                    EssentialsPlugin,
                    BoldPlugin,
                    ItalicPlugin,
                    LinkPlugin,
                    ListPlugin,
                    ParagraphPlugin,
                    AlignmentPlugin,
                    HeadingPlugin
                ],
                toolbar: ['heading', '|', 'bold', 'italic', 'link', 'bulletedList', 'numberedList', 'alignment'],
                alignment: {
                    options: [ 'left', 'center', 'right', 'justify' ]
                },
                heading: {
                    options: [
                        { model: 'paragraph', title: 'Paragraph', class: 'ck-heading_paragraph' },
                        { model: 'heading1', view: 'h1', title: 'Heading 1', class: 'ck-heading_heading1' },
                        { model: 'heading2', view: 'h2', title: 'Heading 2', class: 'ck-heading_heading2' },
                        { model: 'heading3', view: 'h3', title: 'Heading 3', class: 'ck-heading_heading3' }
                    ]
                }
            },
            tableLoading: false,
            dialogLoading: false,
            filterLoading: false,
            status: [{
                label: 'Simpan',
                value: 'draft'
            }, {
                label: 'Publikasikan',
                value: 'publish'
            }],
            filter: {
                keyword: '',
                status: null,
                category: null,
                residential: null,
                author: null
            },
            showDialog: false,
            showFilterDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Ubah Pemberitahuan',
                create: 'Tambah Pemberitahuan'
            },
            announcementForm: {
                id: null,
                title: null,
                status: 'draft',
                category: null,
                author: null,
                residentials: [],
                archived: false,
                owner: null,
                medias: [],
                signedby: [{
                    name: '',
                    position: ''
                }]
            },
            announcementRules: {
                title: [{ 
                    required: true, message: 'Judul pemberitahuan wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'Panjang Judul pemberitahuan maksimal 255 karakter', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z0-9-()&\s/+.,?]{1,255})$/, message: 'Hanya huruf, angka, tanda minus, tanda kurung, ampersand, garis miring, tanda plus, titik, koma dan spasi yang diperbolehkan', trigger: 'blur'
                }],
                status: [{
                    required: true, message: 'Status pemberitahuan wajib diisi', trigger: 'change'
                }],
                category: [{
                    required: true, message: 'Kategori pemberitahuan wajib diisi', trigger: 'change'
                }],
                body: [{ required: true, message: 'Konten pemberitahuan wajib diisi', trigger: 'blur'}]
            },
            uploadFileList: [],
            uploadURL: ''
        };
    },
    computed: {
        tableHeight,
        ...mapGetters('auth', ['token']),
        ...mapGetters('user', ['me', 'users']),
        ...mapGetters('category', ['categories']),
        ...mapGetters('residential', ['residentials']),
        ...mapGetters('announcement', [
            'announcements',
            'pagination'
        ]),
    },
    created() {
        this.getAnnouncements();
        this.getCategories();
        this.getResidentials();    
    },
    methods: {
        playSound,
        dateFormat,
        getAnnouncements() {
            this.tableLoading = true;
            this.$store.dispatch('announcement/getAnnouncements', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getCategories() {
            this.tableLoading = true;
            this.$store.dispatch('category/getCategories', {
                module: 'announcement',
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getResidentials() {
            this.tableLoading = true;
            this.$store.dispatch('residential/getResidentials', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getUsers(q) {
            if(q.trim().length >= 3){
                this.tableLoading = true;
                this.$store.dispatch('user/getUsers', {
                    q: q,
                    page: this.pagination.page,
                    perpage: this.pagination.perpage
                }).then(() => {
                    this.tableLoading = false;
                });
            }
        },
        handleSearch(){

            this.showFilterDialog = false;

            let payload = {
                q: this.filter.keyword,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }

            if(this.filter.status != null){
                payload['status'] = this.filter.status;
            }

            if(this.filter.author != null){
                payload['author'] = this.filter.author;
            }

            if(this.filter.residential != null){
                payload['residential'] = this.filter.residential;
            }

            if(this.filter.category != null){
                payload['category'] = this.filter.category;
            }

            this.tableLoading = true;
            this.$store.dispatch('announcement/getAnnouncements', payload).then(() => {
                this.tableLoading = false;
            });
        },
        handleCreate(){
            this.dialogStatus = 'create';
            this.showDialog = true;          
            this.uploadURL = 'http://api.ringsatu.id/v1/media/tmp';
            this.$nextTick(() => {
                this.$refs['announcementForm'].clearValidate();
            });
        },
        handleEdit(announcement){
            this.dialogStatus = 'edit';
            this.showDialog = true;   
            this.uploadURL = 'http://api.ringsatu.id/v1/media/announcement/'+announcement.id
            this.announcementForm.id = announcement.id;
            this.announcementForm.title = announcement.title;
            this.announcementForm.body = announcement.body;
            this.announcementForm.status = announcement.status;
            this.announcementForm.category = announcement.category.id;
            this.announcementForm.author = announcement.author.id;
            this.announcementForm.archived = announcement.archived;

            if(announcement.signs.length){
                this.announcementForm.signedby = [];
                for(const x of announcement.signs){
                    this.announcementForm.signedby.push({
                        name: x.name,
                        position: x.position
                    });
                }
            }

            if(announcement.residentials.length){
                this.announcementForm.residentials = announcement.residentials.map((x) => x.id);
            }

            if(announcement.medias != null){
                for(const i of announcement.medias){
                    this.announcementForm.medias.push(i.id);
                    this.uploadFileList.push({
                        id: i.id,
                        name: i.original_filename
                    });
                }
            }else{
                this.announcementForm.medias = announcement.medias;
            }

            this.$nextTick(() => {
                this.$refs['announcementForm'].clearValidate()
            });     
        },
        handleDownload(row){
            moment.locale('id');

            var residentials = row.residentials.length ? row.residentials : this.residentials;
            var html = '';

            for(const residential of residentials){
                html += '<div id="pdf-'+residential.id+'" style="font-size:13px!important;line-height:1.6em;"><table style="width:100%;margin-bottom:30px;">'+
                        '<tr>'+
                            '<td style="width: 100%;" valign="top" align="right">'+
                                '<img src="http://my.ringsatu.id/logo-text-only.png" width="200"></br>'+
                                '<strong style="display-block;">'+residential.name+'</strong><br>'+
                                '<small>'+residential.address+' '+residential.administrative_region[0]+', '+residential.administrative_region[1]+', '+residential.administrative_region[2]+', <br>'+
                                residential.administrative_region[3]+', '+residential.administrative_region[4]+'</small>'+
                            '</td>'+
                        '</tr>'+
                    '</table>'+
                    '<strong>'+residential.administrative_region[2].replace(/(Kota|Kab)/g, '')+', '+moment(row.updated).format('DD MMMM YYYY')+'</strong>';

            
                html += '<ul style="padding:0;list-style:none;">'+
                            '<li>'+
                                '<strong style="width:100px;display: block;float: left;margin-right:10px;">No</strong>: '+ row.number +
                            '</li>'+
                            '<li>'+
                                '<strong style="width:100px;display: block;float: left;margin-right:10px;">Perihal</strong>: '+ row.title +
                            '</li>'+
                            '<li>'+
                                '<strong style="width:100px;display: block;float: left;margin-right:10px;">Lampiran</strong>: -'+
                            '</li>'+
                        '</ul>'+
                        '<p>&nbsp;</p>'+
                        '<p>Kepada Yth.<br> Warga '+ residential.name+'<br>' + residential.address + ', ' + residential.administrative_region[0] +', '+ residential.administrative_region[1] + ', ' + residential.administrative_region[2] + ',<br> '+ residential.administrative_region[3] + ', ' + residential.administrative_region[4] +'</p>'+
                        '<p>&nbsp;</p>'+ row.body;

                    if(row.signs.length){
                        html += '<p>&nbsp;</p>'+
                        '<p>&nbsp;</p>'+
                        '<table style="width:100%;">'+
                        '<tr>';
                                    
                        var percent = (100/row.signs.length);

                        for(const x of row.signs){
                            html += '<td style="width: '+percent+'%;">'+
                                        '<span style="text-align:center;">'+
                                            '<u>'+x.name+'</u><br>'+ x.position +
                                        '</span>'+                  
                                    '</td>';
                        }
                    }
                            
                html += '</tr>'+
                        '</table>';
                    '</div>';
            }            

            var opt = {
                margin: 1,
                filename: row.title+'.pdf',
                image: { type: 'jpeg', quality: 0.98 },
                pagebreak: { mode: ['avoid-all', 'css', 'legacy'] },
                html2canvas: { scale: 2 },
                jsPDF: { unit: 'in', format: 'a4', orientation: 'portrait' }
            };

            // New Promise-based usage:
            html2pdf().set(opt).from(html).save();

        },
        handleSubmit(){
            this.$refs.announcementForm.validate((valid) => {
                if(valid){

                    let action = '';
                    let payload = {};

                    this.dialogLoading = true;

                    if(this.dialogStatus == 'create'){
                        action = 'announcement/addAnnouncement';
                        payload = {
                            title: this.announcementForm.title,
                            body: this.announcementForm.body,
                            status: this.announcementForm.status,
                            category: this.announcementForm.category,
                            author: this.announcementForm.author,
                            residentials: this.announcementForm.residentials,
                            medias: this.announcementForm.medias,
                            signedby: this.announcementForm.signedby
                        };
                    }else if(this.dialogStatus == 'edit'){
                        action = 'announcement/editAnnouncement';
                        payload = {
                            id: this.announcementForm.id,
                            title: this.announcementForm.title,
                            body: this.announcementForm.body,
                            status: this.announcementForm.status,
                            category: this.announcementForm.category,
                            author: this.announcementForm.author,
                            residentials: this.announcementForm.residentials,
                            medias: this.announcementForm.medias,
                            archived: this.announcementForm.archived,
                            signedby: this.announcementForm.signedby
                        };
                    }

                    this.$store.dispatch(action, payload).then((response) => {
                        this.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            this.$message.error({
                                message: error.messages
                            });
                        }else{
                            this.showDialog = false;
                            this.$message.success({
                                message: response.message
                            });
                            this.resetForm();
                        }

                        this.playSound();

                    });

                }else{
                    return false;
                }
            });
        },
        handleDelete(announcement){
            this.$confirm('Anda mencoba untuk menghapus data pemberitahuan, data tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('announcement/deleteAnnouncement', {
                    id: announcement.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
        resetForm() {
            this.announcementForm = {
                id: null,
                title: null,
                status: 'draft',
                category: null,
                author: null,
                residentials: [],
                archived: false,
                medias: [],
                signedby: [{
                    name: '',
                    position: ''
                }]
            };

            this.uploadFileList = [];
        },
        beforeUpload(file) {
            if (['image/jpeg', 'image/png', 'application/pdf', 'application/msword', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document', 'application/vnd.ms-excel', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet', 'application/wps-office.docx', 'application/wps-office.doc', 'application/wps-office.xlsx', 'application/wps-office.xls',].indexOf(file.type) < 0) {
                this.$message.error('Hanya image dengan tipe file jpg, png, doc/docx, xls/xlsx dan pdf yang diperbolehkan.');
                return false;
            }
            if (file.size > (8 * 1024 * 1024)) {
                this.$message.error('Ukuran file tidak boleh lebih dari 8MB.');
                return false;
            }
            return true;
        },
        handleUploadSuccess(res) {
            this.announcementForm.medias.push(res.data.media.id);
            this.uploadFileList.push({
                name: res.data.media.original_filename,
                id: res.data.media.id
            });
        },
        handleUploadRemove(file){
            for(const i of this.uploadFileList){
                if(i.id === file.id){
                    this.uploadFileList.splice(i, 1);
                    break;
                }
            }

            let action = '';
            let params = {};

            if(this.dialogStatus == 'create'){
                action = 'media/deleteMediaTmp';
                params.id = file.id;
            }else{
                action = 'media/deleteMedia';
                params.id = file.id;
                params.endpoint = 'announcement';
            }

            this.$store.dispatch(action, params).then((response) => {
                if('errors' in response){
                    let error = parseError(response.errors);
                    this.$message.error({
                        message: error.messages
                    });
                }else{
                    this.$message.success({
                        message: response.message
                    });
                }

                this.playSound();
            });
        },
        addAction() {
            this.announcementForm.signedby.push({
                name: '',
                position: ''
            });
        },
        deleteAction(index) {
            for(const [i, v] of this.announcementForm.signedby.entries()){
                if(i == index){
                    this.announcementForm.signedby.splice(i, 1);                    
                    break;
                }
            }
        }
    }

}
</script>
